diff mbox series

[1/2] tst_net.sh: Fix for disabled IPv6

Message ID 20220124220334.154003-1-petr.vorel@gmail.com
State Changes Requested
Headers show
Series [1/2] tst_net.sh: Fix for disabled IPv6 | expand

Commit Message

Petr Vorel Jan. 24, 2022, 10:03 p.m. UTC
From: Petr Vorel <pvorel@suse.cz>

Tests failed in tst_init_iface even IPv4 only test was run.
Allow to init interfaces at least for IPv4.

Tests which use TST_IPV6=6 needs to be fixed (unless they use
just tst_ipaddr_un()).

Store result into TST_NET_{L,R}HOST_IPV6 in order to cache the result.

Signed-off-by: Petr Vorel <pvorel@suse.cz>
---
Changes v1->v2:
* cache variables with $TST_NET_{L,R}HOST_IPV6 (mdoucha)
NOTE: although I'd prefer to cache the result internally and use
function for detection, tst_net.sh uses variables for most of the
things, thus keep it this way.

Kind regards,
Petr

 testcases/lib/tst_net.sh | 72 ++++++++++++++++++++++++++++++++++------
 1 file changed, 61 insertions(+), 11 deletions(-)

Comments

Petr Vorel Jan. 24, 2022, 10:11 p.m. UTC | #1
Hi,

I forget to add v2.

Kind regards,
Petr
Alexey Kodanev Jan. 25, 2022, 8:32 a.m. UTC | #2
Hi Petr,
On 25.01.2022 01:03, Petr Vorel wrote:
> From: Petr Vorel <pvorel@suse.cz>
> 
> Tests failed in tst_init_iface even IPv4 only test was run.
> Allow to init interfaces at least for IPv4.
> 
> Tests which use TST_IPV6=6 needs to be fixed (unless they use
> just tst_ipaddr_un()).
> 
> Store result into TST_NET_{L,R}HOST_IPV6 in order to cache the result.
> 
> Signed-off-by: Petr Vorel <pvorel@suse.cz>
> ---
> Changes v1->v2:
> * cache variables with $TST_NET_{L,R}HOST_IPV6 (mdoucha)
> NOTE: although I'd prefer to cache the result internally and use
> function for detection, tst_net.sh uses variables for most of the
> things, thus keep it this way.
> 
> Kind regards,
> Petr
> 
>  testcases/lib/tst_net.sh | 72 ++++++++++++++++++++++++++++++++++------
>  1 file changed, 61 insertions(+), 11 deletions(-)
> 
> diff --git a/testcases/lib/tst_net.sh b/testcases/lib/tst_net.sh
> index 4dc0fca92..d1ae3042a 100644
> --- a/testcases/lib/tst_net.sh
> +++ b/testcases/lib/tst_net.sh
> @@ -24,7 +24,9 @@ TST_IPV6_FLAG=${TST_IPV6_FLAG:-}
>  tst_net_parse_args()
>  {
>  	case $1 in
> -	6) TST_IPV6=6 TST_IPVER=6 TST_IPV6_FLAG="-6";;
> +	6)  tst_net_require_ipv6
> +		TST_IPV6=6 TST_IPVER=6 TST_IPV6_FLAG="-6"
> +		;;
>  	*) [ "$TST_PARSE_ARGS_CALLER" ] && $TST_PARSE_ARGS_CALLER "$1" "$2";;
>  	esac
>  }
> @@ -100,6 +102,30 @@ tst_brk_()
>  	[ -z "$TST_USE_LEGACY_API" ] && tst_brk $@ || tst_brkm $@
>  }
>  
> +tst_net_detect_ipv6()
> +{
> +	local type="${1:-lhost}"
> +	local cmd='[ -f /proc/net/if_inet6 ]'
> +
> +	if [ "$type" = "lhost" ]; then
> +		$cmd
> +		return $?
> +	fi
> +
> +	tst_rhost_run -c "$cmd"
> +	return $?
> +}
> +
> +tst_net_require_ipv6()
> +{
> +	local err="IPv6 not supported on:"
> +	local missing
> +
> +	[ "$TST_NET_LHOST_IPV6" = 1 ] || missing=" lhost"
> +	[ "$TST_NET_RHOST_IPV6" = 1 ] || missing="$missing rhost"
> +	[ -z "$missing" ] || tst_brk_ TCONF "$err$missing"
> +}
> +
>  init_ltp_netspace()
>  {
>  	local pid
> @@ -517,7 +543,9 @@ tst_init_iface()
>  		ip link set $iface down || return $?
>  		ip route flush dev $iface || return $?
>  		ip addr flush dev $iface || return $?
> -		sysctl -qw net.ipv6.conf.$iface.accept_dad=0 || return $?
> +		if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> +			sysctl -qw net.ipv6.conf.$iface.accept_dad=0 || return $?
> +		fi
>  		ip link set $iface up
>  		return $?
>  	fi
> @@ -529,7 +557,9 @@ tst_init_iface()
>  	tst_rhost_run -c "ip link set $iface down" || return $?
>  	tst_rhost_run -c "ip route flush dev $iface" || return $?
>  	tst_rhost_run -c "ip addr flush dev $iface" || return $?
> -	tst_rhost_run -c "sysctl -qw net.ipv6.conf.$iface.accept_dad=0" || return $?
> +	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
> +		tst_rhost_run -c "sysctl -qw net.ipv6.conf.$iface.accept_dad=0" || return $?
> +	fi
>  	tst_rhost_run -c "ip link set $iface up"
>  }
>  
> @@ -606,7 +636,9 @@ tst_restore_ipaddr()
>  	local ret=0
>  	local backup_tst_ipv6=$TST_IPV6
>  	TST_IPV6= tst_add_ipaddr $type $link_num || ret=$?
> -	TST_IPV6=6 tst_add_ipaddr $type $link_num || ret=$?
> +	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> +		TST_IPV6=6 tst_add_ipaddr $type $link_num || ret=$?
> +	fi
>  	TST_IPV6=$backup_tst_ipv6
>  
>  	return $ret
> @@ -971,8 +1003,16 @@ IPV6_RHOST="${IPV6_RHOST:-fd00:1:1:1::1/64}"
>  if [ -z "$_tst_net_parse_variables" ]; then
>  	eval $(tst_net_ip_prefix $IPV4_LHOST || echo "exit $?")
>  	eval $(tst_net_ip_prefix -r $IPV4_RHOST || echo "exit $?")
> -	eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
> -	eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
> +
> +	tst_net_detect_ipv6 && TST_NET_LHOST_IPV6=1
> +	tst_net_detect_ipv6 rhost && TST_NET_RHOST_IPV6=1
> +
> +	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> +		eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
> +	fi
> +	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
> +		eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
> +	fi

Do we really need to keep around and check two variables? If at least
one machine doesn't have IPv6, it's not longer necessary to setup the
other.

>  fi
>  
>  [ -n "$TST_USE_NETNS" -a "$TST_INIT_NETNS" != "no" ] && init_ltp_netspace
> @@ -981,19 +1021,29 @@ if [ -z "$_tst_net_parse_variables" ]; then
>  	eval $(tst_net_iface_prefix $IPV4_LHOST || echo "exit $?")
>  	eval $(tst_rhost_run -c 'tst_net_iface_prefix -r '$IPV4_RHOST \
>  		|| echo "exit $?")
> -	eval $(tst_net_iface_prefix $IPV6_LHOST || echo "exit $?")
> -	eval $(tst_rhost_run -c 'tst_net_iface_prefix -r '$IPV6_RHOST \
> -		|| echo "exit $?")
> +
> +	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> +		eval $(tst_net_iface_prefix $IPV6_LHOST || echo "exit $?")
> +	fi
> +
> +	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
> +		eval $(tst_rhost_run -c 'tst_net_iface_prefix -r '$IPV6_RHOST \
> +			|| echo "exit $?")
> +	fi
>  
>  	eval $(tst_net_vars $IPV4_LHOST/$IPV4_LPREFIX \
>  		$IPV4_RHOST/$IPV4_RPREFIX || echo "exit $?")
> -	eval $(tst_net_vars $IPV6_LHOST/$IPV6_LPREFIX \
> -		$IPV6_RHOST/$IPV6_RPREFIX || echo "exit $?")
> +
> +	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> +		eval $(tst_net_vars $IPV6_LHOST/$IPV6_LPREFIX \
> +			$IPV6_RHOST/$IPV6_RPREFIX || echo "exit $?")
> +	fi
>  
>  	tst_res_ TINFO "Network config (local -- remote):"
>  	tst_res_ TINFO "$LHOST_IFACES -- $RHOST_IFACES"
>  	tst_res_ TINFO "$IPV4_LHOST/$IPV4_LPREFIX -- $IPV4_RHOST/$IPV4_RPREFIX"
>  	tst_res_ TINFO "$IPV6_LHOST/$IPV6_LPREFIX -- $IPV6_RHOST/$IPV6_RPREFIX"
> +
>  	export _tst_net_parse_variables="yes"
>  fi
>
Petr Vorel Jan. 25, 2022, 9:08 a.m. UTC | #3
Hi Alexey, all,

...
> > @@ -971,8 +1003,16 @@ IPV6_RHOST="${IPV6_RHOST:-fd00:1:1:1::1/64}"
> >  if [ -z "$_tst_net_parse_variables" ]; then
> >  	eval $(tst_net_ip_prefix $IPV4_LHOST || echo "exit $?")
> >  	eval $(tst_net_ip_prefix -r $IPV4_RHOST || echo "exit $?")
> > -	eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
> > -	eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
> > +
> > +	tst_net_detect_ipv6 && TST_NET_LHOST_IPV6=1
> > +	tst_net_detect_ipv6 rhost && TST_NET_RHOST_IPV6=1
> > +
> > +	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> > +		eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
> > +	fi
> > +	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
> > +		eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
> > +	fi

> Do we really need to keep around and check two variables? If at least
> one machine doesn't have IPv6, it's not longer necessary to setup the
> other.

OK, just one variable is enough, e.g. TST_NET_REQUIRE_IPV6.

@all: But netns_helper.sh, which does not use tst_net.sh also requires IPv6
(and there are probably more), thus how about adding flag TST_REQUIRE_IPV6
into tst_test.sh (would help also for documentation - docparse).
And tst_net.sh would just on check also IPv6 on rhost.

Kind regards,
Petr
Petr Vorel Feb. 2, 2022, 10:32 a.m. UTC | #4
Hi all,

> Hi Alexey, all,

> ...
> > > @@ -971,8 +1003,16 @@ IPV6_RHOST="${IPV6_RHOST:-fd00:1:1:1::1/64}"
> > >  if [ -z "$_tst_net_parse_variables" ]; then
> > >  	eval $(tst_net_ip_prefix $IPV4_LHOST || echo "exit $?")
> > >  	eval $(tst_net_ip_prefix -r $IPV4_RHOST || echo "exit $?")
> > > -	eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
> > > -	eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
> > > +
> > > +	tst_net_detect_ipv6 && TST_NET_LHOST_IPV6=1
> > > +	tst_net_detect_ipv6 rhost && TST_NET_RHOST_IPV6=1
> > > +
> > > +	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
> > > +		eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
> > > +	fi
> > > +	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
> > > +		eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
> > > +	fi

> > Do we really need to keep around and check two variables? If at least
> > one machine doesn't have IPv6, it's not longer necessary to setup the
> > other.

> OK, just one variable is enough, e.g. TST_NET_REQUIRE_IPV6.

> @all: But netns_helper.sh, which does not use tst_net.sh also requires IPv6
> (and there are probably more), thus how about adding flag TST_REQUIRE_IPV6
> into tst_test.sh (would help also for documentation - docparse).
Going to add it to v3.

> And tst_net.sh would just on check also IPv6 on rhost.

I found that no C test needs a special flag for handling IPv6 because we can
filter it with errno EAFNOSUPPORT. We should just remember tests first use IPv4
(e.g. in bind05.c), because functions behind SAFE_* macros use tst_brk.

@Cyril: I suppose we don't want to have kind of info flag "uses_ipv6" in C API
(for docparse), right?

Kind regards,
Petr

> Kind regards,
> Petr
diff mbox series

Patch

diff --git a/testcases/lib/tst_net.sh b/testcases/lib/tst_net.sh
index 4dc0fca92..d1ae3042a 100644
--- a/testcases/lib/tst_net.sh
+++ b/testcases/lib/tst_net.sh
@@ -24,7 +24,9 @@  TST_IPV6_FLAG=${TST_IPV6_FLAG:-}
 tst_net_parse_args()
 {
 	case $1 in
-	6) TST_IPV6=6 TST_IPVER=6 TST_IPV6_FLAG="-6";;
+	6)  tst_net_require_ipv6
+		TST_IPV6=6 TST_IPVER=6 TST_IPV6_FLAG="-6"
+		;;
 	*) [ "$TST_PARSE_ARGS_CALLER" ] && $TST_PARSE_ARGS_CALLER "$1" "$2";;
 	esac
 }
@@ -100,6 +102,30 @@  tst_brk_()
 	[ -z "$TST_USE_LEGACY_API" ] && tst_brk $@ || tst_brkm $@
 }
 
+tst_net_detect_ipv6()
+{
+	local type="${1:-lhost}"
+	local cmd='[ -f /proc/net/if_inet6 ]'
+
+	if [ "$type" = "lhost" ]; then
+		$cmd
+		return $?
+	fi
+
+	tst_rhost_run -c "$cmd"
+	return $?
+}
+
+tst_net_require_ipv6()
+{
+	local err="IPv6 not supported on:"
+	local missing
+
+	[ "$TST_NET_LHOST_IPV6" = 1 ] || missing=" lhost"
+	[ "$TST_NET_RHOST_IPV6" = 1 ] || missing="$missing rhost"
+	[ -z "$missing" ] || tst_brk_ TCONF "$err$missing"
+}
+
 init_ltp_netspace()
 {
 	local pid
@@ -517,7 +543,9 @@  tst_init_iface()
 		ip link set $iface down || return $?
 		ip route flush dev $iface || return $?
 		ip addr flush dev $iface || return $?
-		sysctl -qw net.ipv6.conf.$iface.accept_dad=0 || return $?
+		if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
+			sysctl -qw net.ipv6.conf.$iface.accept_dad=0 || return $?
+		fi
 		ip link set $iface up
 		return $?
 	fi
@@ -529,7 +557,9 @@  tst_init_iface()
 	tst_rhost_run -c "ip link set $iface down" || return $?
 	tst_rhost_run -c "ip route flush dev $iface" || return $?
 	tst_rhost_run -c "ip addr flush dev $iface" || return $?
-	tst_rhost_run -c "sysctl -qw net.ipv6.conf.$iface.accept_dad=0" || return $?
+	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
+		tst_rhost_run -c "sysctl -qw net.ipv6.conf.$iface.accept_dad=0" || return $?
+	fi
 	tst_rhost_run -c "ip link set $iface up"
 }
 
@@ -606,7 +636,9 @@  tst_restore_ipaddr()
 	local ret=0
 	local backup_tst_ipv6=$TST_IPV6
 	TST_IPV6= tst_add_ipaddr $type $link_num || ret=$?
-	TST_IPV6=6 tst_add_ipaddr $type $link_num || ret=$?
+	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
+		TST_IPV6=6 tst_add_ipaddr $type $link_num || ret=$?
+	fi
 	TST_IPV6=$backup_tst_ipv6
 
 	return $ret
@@ -971,8 +1003,16 @@  IPV6_RHOST="${IPV6_RHOST:-fd00:1:1:1::1/64}"
 if [ -z "$_tst_net_parse_variables" ]; then
 	eval $(tst_net_ip_prefix $IPV4_LHOST || echo "exit $?")
 	eval $(tst_net_ip_prefix -r $IPV4_RHOST || echo "exit $?")
-	eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
-	eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
+
+	tst_net_detect_ipv6 && TST_NET_LHOST_IPV6=1
+	tst_net_detect_ipv6 rhost && TST_NET_RHOST_IPV6=1
+
+	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
+		eval $(tst_net_ip_prefix $IPV6_LHOST || echo "exit $?")
+	fi
+	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
+		eval $(tst_net_ip_prefix -r $IPV6_RHOST || echo "exit $?")
+	fi
 fi
 
 [ -n "$TST_USE_NETNS" -a "$TST_INIT_NETNS" != "no" ] && init_ltp_netspace
@@ -981,19 +1021,29 @@  if [ -z "$_tst_net_parse_variables" ]; then
 	eval $(tst_net_iface_prefix $IPV4_LHOST || echo "exit $?")
 	eval $(tst_rhost_run -c 'tst_net_iface_prefix -r '$IPV4_RHOST \
 		|| echo "exit $?")
-	eval $(tst_net_iface_prefix $IPV6_LHOST || echo "exit $?")
-	eval $(tst_rhost_run -c 'tst_net_iface_prefix -r '$IPV6_RHOST \
-		|| echo "exit $?")
+
+	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
+		eval $(tst_net_iface_prefix $IPV6_LHOST || echo "exit $?")
+	fi
+
+	if [ "$TST_NET_RHOST_IPV6" = 1 ]; then
+		eval $(tst_rhost_run -c 'tst_net_iface_prefix -r '$IPV6_RHOST \
+			|| echo "exit $?")
+	fi
 
 	eval $(tst_net_vars $IPV4_LHOST/$IPV4_LPREFIX \
 		$IPV4_RHOST/$IPV4_RPREFIX || echo "exit $?")
-	eval $(tst_net_vars $IPV6_LHOST/$IPV6_LPREFIX \
-		$IPV6_RHOST/$IPV6_RPREFIX || echo "exit $?")
+
+	if [ "$TST_NET_LHOST_IPV6" = 1 ]; then
+		eval $(tst_net_vars $IPV6_LHOST/$IPV6_LPREFIX \
+			$IPV6_RHOST/$IPV6_RPREFIX || echo "exit $?")
+	fi
 
 	tst_res_ TINFO "Network config (local -- remote):"
 	tst_res_ TINFO "$LHOST_IFACES -- $RHOST_IFACES"
 	tst_res_ TINFO "$IPV4_LHOST/$IPV4_LPREFIX -- $IPV4_RHOST/$IPV4_RPREFIX"
 	tst_res_ TINFO "$IPV6_LHOST/$IPV6_LPREFIX -- $IPV6_RHOST/$IPV6_RPREFIX"
+
 	export _tst_net_parse_variables="yes"
 fi